import swarm.simtoolsgui.*;
import swarm.*;
import swarm.activity.*;
import swarm.analysis.*;
import swarm.objectbase.*;
import swarm.defobj.*;

/**
 * ExperSwarm͕̃f(ModelSwarm)V~[gB<BR>
 * <BR>
 * f̃p[^ݒ肷镔ParameterManagerƂĕʃNXɕĂB
 */
public class ExperSwarm extends GUISwarmImpl{
	int modelTime; // model run time
	public int numModelsRun; // number of models run
	
	ActionGroup experActions; // schedule data structs
	Schedule experSchedule;
	
	ModelSwarm modelSwarm; // the Swarm we're iterating
	
	ParameterManager parameterManager; // An object to manage model parameters
	
	// |
	//File logFile; // File to log run results
	
	// Display objects, widgets, etc.
	
	EZGraph resultGraph; // graphing widget
	EmptyProbeMap modelProbeMap; // the ProbeMap for the modelSwarm
	
	public ExperSwarm(Zone aZone){
		super(aZone);
		EmptyProbeMap theProbeMap;
		
		numModelsRun=0;
		
		theProbeMap=new EmptyProbeMapImpl(aZone,this.getClass());
		theProbeMap.addProbe(
			Globals.env.probeLibrary.getProbeForVariable$inClass(
				"numModelsRun",this.getClass()));
		Globals.env.probeLibrary.setProbeMap$For(theProbeMap,this.getClass());
	}
	
	public Object _resultGraphDeath_(Object caller){
		resultGraph.drop();
		resultGraph = null;
		return this;
	}
	
	/**
	 * ܂A܂łƈقȂAbuildObjectsModelSwarm̃IuWFNg
	 * ȂƂɒӁB	 * ōŝ́AProbe̐A  EZGraph̐A
	 * ʂo͂邽߂̃t@C"log.file"̐i͖|jłB<BR>
	 * <BR>
	 * ModelSwarm̓V~[VŐEpJԂ߁A
	 * \bhbuildModelɂ܂Ƃ߂B
	 */
	public Object buildObjects(){
		super.buildObjects();
		
		// Build the parameter manager, using the parameterManager data stored in
		// the `bug.scm' datafile.
		
		parameterManager = (ParameterManager)
			Globals.env.lispAppArchiver.getWithZone$key(this,"parameterManager");
		if(parameterManager==null){
			System.out.println("Can't find the parameterManager parameters.");
			System.exit(1);
		}
		parameterManager.initializeParameters(this);
		
		// Build a probeDisplay on ourself
		
		Globals.env.createArchivedProbeDisplay (this, "experSwarm");
		
		// build the EZGraph for model results
		
		resultGraph=new EZGraphImpl(
			this,"Model Run Times","Model #","Run Time","resultGraph");
		
		try {
			resultGraph.enableDestroyNotification$notificationMethod
			  (this, new Selector(getClass(),"_resultGraphDeath_",false));
		} catch (Exception e) {
			System.err.println ("Exception _resultGraphDeath_: "+e.getMessage());
		}
		
		// Create a sequence to track model run times.
		// Since we keep changing models, we feed from our own method
		// "getModelTime" which will probe the correct instance of 
		// ModelSwarm
		
		try {
			resultGraph.createSequence$withFeedFrom$andSelector(
				"runTime",this,new Selector(
				this.getClass(),"getModelTime", false));
		} catch (Exception e) {
			System.err.println ("Exception: " + e.getMessage());
		}
		
		// Allow the user to alter experiment parameters
		
		getControlPanel().setStateStopped();
		
		// Create the OutFile object to log the runs
		//|
		//logFile = [OutFile create: self setName: "log.file"];
		
		return this;
	}
	
	/**
	 * ActionGroupÃANVԂɓo^B
	 * ActionGroupXPW[ɓo^邱ƂŁAsB
	 * ̂悤ɁAANV̓O[vĊǗ邱ƂłB
	 */
	public Object buildActions(){
		super.buildActions();
		experActions=new ActionGroupImpl(this);
		
		try {
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"buildModel",false));
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"runModel",false));
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"doStats",false));
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"showStats",false));
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"logResults",false));
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"dropModel",false));
			
			// Check to see if the experiment has ended (all the models have been run).
			
			experActions.createActionTo$message(this,
				new Selector(this.getClass(),"checkToStop",false));
			
			// Schedule the update of the probe display
			
			experActions.createActionTo$message(Globals.env.probeDisplayManager,
				new Selector(Globals.env.probeDisplayManager.getClass(),"update",false));
			
			// Finally, schedule an update for the whole user interface code.
			
			experActions.createActionTo$message(
				getActionCache(),
				new Selector(getActionCache().getClass(),"doTkEvents",true));
				
		} catch (Exception e) {
			System.out.println ("Exception: " + e.getMessage ());
			System.exit(1);
		}
		
		experSchedule = new ScheduleImpl(this,1);
		experSchedule.at$createAction(0,experActions);
		
		return this;
	}


	public Activity activateIn(Swarm context){
		super.activateIn(context);
		experSchedule.activateIn(this);
		return getActivity();
	}
	
	/**
	 * ModelSwarm𐶐B<BR>
	 * vOModelSwarm͉x邪A
	 * ModelSwarm̂߂Probe͍ŏɈ񐶐΂悢B<BR>
	 * <BR>
	 * ModelSwarmactivatếAExperSwarmł͂ȂAnullłłB
	 * ́AExperSwarm̃^CXebvModelSwarm̃^CXebvႤ߂łB
	 * ̂߁AExperSwarm̃XPW[ModelSwarm̃XPW[
	 * }[W邱Ƃ͂łȂB
	 */
	public Object buildModel(){
		modelSwarm=new ModelSwarm(this);
		
		// If this is the first model, create a custom probeMap for modelSwarm
		// and construct a graph displaying model results
		
		if(numModelsRun==0){
			modelProbeMap=new EmptyProbeMapImpl(this,modelSwarm.getClass());
			
			modelProbeMap.addProbe(
				Globals.env.probeLibrary.getProbeForVariable$inClass(
					"worldXSize",modelSwarm.getClass()));
			modelProbeMap.addProbe(
				Globals.env.probeLibrary.getProbeForVariable$inClass(
					"worldYSize",modelSwarm.getClass()));
			modelProbeMap.addProbe(
				Globals.env.probeLibrary.getProbeForVariable$inClass(
					"seedProb",modelSwarm.getClass()));
			modelProbeMap.addProbe(
				Globals.env.probeLibrary.getProbeForVariable$inClass(
					"bugDensity",modelSwarm.getClass()));
			
			Globals.env.probeLibrary.setProbeMap$For(
				modelProbeMap,modelSwarm.getClass());
		}
		
		// Now, we invoke the parameterManager to initialize the model
		
		parameterManager.initializeModel(modelSwarm);
		
		modelSwarm.buildObjects();
		modelSwarm.buildActions();
		modelSwarm.activateIn(null);
		
		return this;
	}
	
	/**
	 * ModelSwarmAactivateAModelSwarm𑖂点B
	 * ModelSwarmterminateA͂ɖ߂ĂB<BR>
	 */
	public Object runModel(){
		System.out.println("\nStarting model "+(numModelsRun+1)+"\n");
		
		modelSwarm.getActivity().run();
		
		System.out.println("\nModel "+(numModelsRun+1)+" is done\n");
		
		numModelsRun++; // increment count of models
		
		return this;
	}
	

	/**
	 * ModelSwarmtime擾A\B
	 */
	public Object doStats(){
		modelTime=modelSwarm.getTime();
		System.out.println("Length of this run = "+modelTime+"\n");
		return this;
	}
	
	/**
	 * EZGraphɃf[^n߂̃\bhB
	 * EZGraphModelSwarm璼time擾邱Ƃ͂łȂB
	 * ȂȂAModelSwarm̃CX^XĂȂA
	 * CX^Xς肷邩łB
	 * @return ModelSwarmtimeԂ 
	 */
	public int getModelTime(){
		return modelSwarm.getTime();
	}
	
	/**
	 * |
	 * This uses the OutFile object to log the parameters 
	 * and results of a run to the file "log.file".<BR>
	 * <BR>
	 *   This makes use of an OutFile object to archive the parameter settings and 
	 * results for each run of the model. It asks the ParameterManager to print
	 * out its state into the file as well, so the specific parameters for
	 * each run will be recorded together with the results of the run.
	 */
	public Object logResults(){
		/* |
		// This uses the OutFile object to log the parameters 
		// and results of a run to the file "log.file"
		
		[logFile putString: "--------------------------------\n\n"];
		
		[logFile putString: "Model # "]; 
		[logFile putInt: numModelsRun];
		
		[logFile putNewLine];
		
		// have the parameterManager log its state
		[parameterManager printParameters: logFile];
		
		[logFile putNewLine];
		
		[logFile putString: "Time for this run = "];
		[logFile putInt: modelTime];
		
		[logFile putNewLine];
		*/
		return this;
	}
	
	/**
	 * resultGraph`悷B̑ExperSwarm̃XPW[ɓo^邱ƂłB
	 * Ȃ̂́Aʂ̃OtꍇɁAstep邾ł悤
	 * 邽߂łBɂāAXPW[VvɕۂƂłB
	 */
	public Object showStats(){
		if(resultGraph!=null)
			resultGraph.step(); // step the result Graph
		return this;
	}
	
	/**
	 * ModelSwam̖IȃfXgN^B
	 * ModelSwarmFoodSpaceWorlddropB
	 * iKxbWERN^Javaɂ̂悤ȑ͕KvȂ悤ɎvB
	 * ہAꂪȂĂvO͓삷Bj
	 */
	public Object dropModel(){
		modelSwarm.drop();
		return this;
	}
	
	/**
	 * ׂẴfsIB<BR>
	 * <BR>
	 * parameterManager̃\bhstepParametersIfĂяoB
	 * ׂẴfsIĂꍇAnullԂ邽߁A
	 * ̏I킩B
	 */
	public Object checkToStop(){
		if(parameterManager.stepParameters()==null){
			Globals.env.probeDisplayManager.update();
			getActionCache().doTkEvents();
			
			System.out.println("\n All the models have run!\n");
			
			//|
			//logFile.drop();
			getControlPanel().setStateStopped();
		}
		return this;
	}
}
